/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.broker;
import ojb.broker.metadata.*;


/**
 * 
 * ConversionStrategy declares a protocol for type and Value conversions
 * between Java objects and SQL types and values.
 * The default implementation does not modify its input.
 * But OJB users are free to build their own conversions that perform
 * arbitrary mappings.
 * the mapping has to defined in the xml repository.
 *
 * @author <a href="mailto:thomas.mahler@itellium.com">Thomas Mahler<a>
 * 
 */
public interface ConversionStrategy
{
		/** convert a Java object to its SQL pendant, used for insert & update*/
	public abstract Object javaToSql(Object source, FieldDescriptor fld);

	/** convert a SQL value to a Java Object, used for SELECT*/
	public abstract Object sqlToJava(Object source, FieldDescriptor fld);

}