/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.broker;
import java.util.List;

/**
 * 
 * The Interface ObjectModification represents information about
 * 
 * modifications of persistence capable objects.
 * 
 * Allows clients of the PersistenceBroker (e.g. a TransactionServer)
 * 
 * to interact with the Broker in order to generate optimized SQL Statements.
 * 
 * @author: Thomas Mahler
 * 
 */
public interface ObjectModification extends java.io.Serializable
{

	/**
	 * returns true if the underlying Object needs an INSERT statement.
	 * 
	 * Else Returns false.
	 * 
	 */
	public boolean needsInsert();

	/**
	 * returns true if the underlying Object needs an UPDATE statement.
	 * 
	 * Else Returns false.
	 * 
	 */
	public boolean needsUpdate();
}