package ojb.broker;

/** 
 * Konfiguration des Zugriffs auf Objy
 */
public class PersistenceBrokerFactoryConfiguration extends BaseConfiguration
{
	/** use Server or local broker*/
	private boolean serverUsed;

    /** the repository file keeping the O/R Metadata*/
	private String repositoryFilename;

	private String[] servers;


    public boolean isServerUsed()
    {
        return serverUsed;
    }

    public String getRepositoryFilename()
    {
        return repositoryFilename;
    }

    public String[] getServers()
    {
        return servers;
    }

    /** ldt die Konfiguration*/
    protected void load()
    {
    	super.load();


    	//Usage of local or remote Broker
    	serverUsed = (getProperty("useServer", "false").equalsIgnoreCase("true") ? true : false );
        repositoryFilename = getProperty("repositoryFile", "repository.xml");
        String strServers = getProperty("BrokerServers", "localhost:2001");

        servers = parseSeparatedString(strServers, ";");


    	save("OJB Configuration");
    }
}
