/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.broker.metadata;
import java.util.Vector;
import java.lang.reflect.Field;

/**
 * 
 * mapping Description for member fields that are Collections
 * 
 * 
 * 
 * @author <a href="mailto:thomas.mahler@itellium.com">Thomas Mahler<a>
 * 
 */
public class CollectionDescriptor extends ObjectReferenceDescriptor
{

	/**
	 * Represents the type of the collection, if set to null, a java.util.Vector will be used.
	 * 
	 * If set to a valid collection type it will be used to build typed collections.
	 * 
	 */
	private Class collectionClass = null;

	/**
	 * 
	 * returns the type of the collection.
	 * 
	 * @return java.lang.Class
	 * 
	 */
	public java.lang.Class getCollectionClass()
	{
		return collectionClass;
	}

	/**
	 * set the type of the collection
	 */
	public void setCollectionClass(Class c)
	{
		collectionClass = c;
	}

}