/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.broker.metadata;
import java.lang.reflect.Field;
import java.util.Comparator;
import java.util.Vector;

/**
 * 
 * A FieldDescriptor holds the mapping information for a specific member-variable
 * 
 * 
 * 
 * @author <a href="mailto:thomas.mahler@itellium.com">Thomas Mahler<a>
 * 
 */
public class FieldDescriptor extends AttributeDescriptorBase
{
	private int m_ColNo;
	private String m_ColumnName;
	private String m_ColumnType;
	private boolean m_IsKeyField;

	/**
	 * Constructor declaration
	 * 
	 * 
	 * @param id
	 * 
	 * @see
	 */
	public FieldDescriptor(int id)
	{
		m_ColNo = id;
	}

	/**
	 * 
	 * returns a comparator that allows to sort a Vector of FieldMappingDecriptors
	 * 
	 * according to their m_Order entries.
	 * 
	 */
	public static Comparator getComparator()
	{
		return new Comparator()
		{

			/**
			 * Method declaration
			 * 
			 * 
			 * @param o1
			 * @param o2
			 * 
			 * @return
			 * 
			 * @see
			 */
			public int compare(Object o1, Object o2)
			{
				FieldDescriptor fmd1 = (FieldDescriptor) o1;
				FieldDescriptor fmd2 = (FieldDescriptor) o2;
				if (fmd1.getColNo() < fmd2.getColNo())
				{
					return -1;
				}
				if (fmd1.getColNo() > fmd2.getColNo())
				{
					return 1;
				}
				else
				{
					return 0;
				}
			}

		};
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getColumnName()
	{
		return m_ColumnName;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setColumnName(String str)
	{
		m_ColumnName = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getColumnType()
	{
		return m_ColumnType;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setColumnType(String str)
	{
		m_ColumnType = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public boolean isPrimaryKey()
	{
		return m_IsKeyField;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param b
	 * 
	 * @see
	 */
	public void setPrimaryKey(boolean b)
	{
		m_IsKeyField = b;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public int getColNo()
	{
		return m_ColNo;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String toString()
	{
		return "\n\n" + getPersistentField().toString() + "\n" + m_ColumnName + "\n" + m_ColumnType 
			   + "\n" + m_IsKeyField + "\n" + m_ColNo;
	}

}