/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.broker.metadata;
import java.util.Properties;
import java.io.*;

/**
 * 
 * JdbcConnectionDescriptor describes all relevant parameters of JDBC Connections
 * 
 * used by the PersistenceBroker
 * 
 * 
 * 
 * @author <a href="mailto:thomas.mahler@itellium.com">Thomas Mahler<a>
 * 
 */
public class JdbcConnectionDescriptor
{
	protected String m_Dbms = null;
	protected String m_Scheme = null;
	protected String m_Driver = null;
	protected String m_Protocol = null;
	protected String m_SubProtocol = null;
	protected String m_DbAlias = null;
	protected String m_UserName = null;
	protected String m_Password = null;

	/**
	 * Constructor declaration
	 * 
	 * 
	 * @see
	 */
	public JdbcConnectionDescriptor() {}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String toString()
	{
		return "JdbcConnectionDescriptor\n" + m_Dbms + "\n" + m_Scheme + "\n" + m_Driver + "\n" 
			   + m_Protocol + "\n" + m_SubProtocol + "\n" + m_DbAlias + "\n" + m_UserName + "\n" 
			   + m_Password;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getDbms()
	{
		return m_Dbms;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setDbms(String str)
	{
		m_Dbms = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getScheme()
	{
		return m_Scheme;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setScheme(String str)
	{
		m_Scheme = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getDriver()
	{
		return m_Driver;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setDriver(String str)
	{
		m_Driver = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getProtocol()
	{
		return m_Protocol;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setProtocol(String str)
	{
		m_Protocol = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getSubProtocol()
	{
		return m_SubProtocol;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setSubProtocol(String str)
	{
		m_SubProtocol = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getDbAlias()
	{
		return m_DbAlias;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setDbAlias(String str)
	{
		m_DbAlias = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getUserName()
	{
		return m_UserName;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setUserName(String str)
	{
		m_UserName = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getPassWord()
	{
		return m_Password;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param str
	 * 
	 * @see
	 */
	public void setPassWord(String str)
	{
		m_Password = str;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getDbms(JdbcConnectionDescriptor def)
	{
		if (m_Dbms == null)
		{
			return def.getDbms();
		}
		else
		{
			return m_Dbms;
		}
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getScheme(JdbcConnectionDescriptor def)
	{
		if (m_Scheme == null)
		{
			return def.getScheme();
		}
		else
		{
			return m_Scheme;
		}
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getDriver(JdbcConnectionDescriptor def)
	{
		if (m_Driver == null)
		{
			return def.getDriver();
		}
		else
		{
			return m_Driver;
		}
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getProtocol(JdbcConnectionDescriptor def)
	{
		if (m_Protocol == null)
		{
			return def.getProtocol();
		}
		else
		{
			return m_Protocol;
		}
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getSubProtocol(JdbcConnectionDescriptor def)
	{
		if (m_SubProtocol == null)
		{
			return def.getSubProtocol();
		}
		else
		{
			return m_SubProtocol;
		}
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getDbAlias(JdbcConnectionDescriptor def)
	{
		if (m_DbAlias == null)
		{
			return def.getDbAlias();
		}
		else
		{
			return m_DbAlias;
		}
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getUserName(JdbcConnectionDescriptor def)
	{
		if (m_UserName == null)
		{
			return def.getUserName();
		}
		else
		{
			return m_UserName;
		}
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param def
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getPassWord(JdbcConnectionDescriptor def)
	{
		if (m_Password == null)
		{
			return def.getPassWord();
		}
		else
		{
			return m_Password;
		}
	}

}