/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * $Id: CriteriaException.java,v 1.7 2001/06/01 19:22:16 thma Exp $
 * COBRA - Java Object Persistence Layer
 * Copyright (C) 1997, 1998    DB Harvey-George
 * eMail: cobra@kimble.co.uk
 * 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package ojb.broker.query;
import java.lang.Exception;

/**
 * The only exception type thrown by COBRA is PersistentException
 * 
 * @author DB Harvey-George
 * @revision $Revision: 1.7 $
 */
public class CriteriaException extends Exception
{

	/**
	 * Constructs an exception without cause or reason.
	 */
	public CriteriaException()
	{
		this("An exception for no reason whatsoever.");
	}

	/**
	 * Constructs a new exception for the specified reason.
	 * @param reason the reason the operation failed
	 */
	public CriteriaException(String reason)
	{
		super(reason);
	}

	/**
	 * Constructs a new exception caused by the specified exception.
	 * @param e the exception causing the operation to fail
	 */
	public CriteriaException(Exception e)
	{
		super(e.getMessage());
	}

}