/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package ojb.broker.query;

/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * represents Queries that can be used by the OJB PersistenceBroker
 * to retrieve Objects from the underlying DB.
 * Until now there are two implementations:
 * 1. QueryByCriteria, represents SELECT * FROM ... WHERE ... queries
 * 2. QueryByExample, uses Example objects or OIDs
 * as templates for the db lookup
 * there could additional implementations, e.g for user defined SQL
 * 
 * For the Criteria API I reused code from the COBRA project,
 * as you will see by their class comments.
 * 
 * I removed all stuff that relies on knowlegde of the DataDictionary
 * or MetaData layer. The Query and Criteria classes thus don't know
 * how to build SQL statements, as in the COBRA original sources.
 * I use the this classes as mere data-structures, that are
 * processed by the OJB Accesslayer (SqlGenerator, JdbcAccess).
 * 
 * This design will allow to reuse the ojb.broker.query package in other
 * projects without breaking any references. I hope this will be
 * useful for someone.
 * 
 */
public interface Query extends java.io.Serializable
{

	/**
	 * return the criteria of the query if present or null.
	 */
	public abstract Criteria getCriteria();

	/**
	 * return the template Object if present or null
	 */
	public abstract Object getExampleObject();

	/**
	 * return the target class, representing the extend to be searched
	 */
	public abstract Class getSearchClass();
}