/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package ojb.broker.query;
import java.util.Enumeration;
import ojb.broker.metadata.*;

/**
 * represents a search by criteria.
 * "find all articles where article.price > 100"
 * could be represented as:
 * 
 * Criteria crit = new Criteria();
 * crit.addGreaterThan("price", new Double(100));
 * Query qry = new QueryByCriteria(Article.class, crit);
 * 
 * The PersistenceBroker can retrieve Objects by Queries as follows:
 * 
 * PersistenceBroker broker = PersistenceBrokerFactory.createPersistenceBroker();
 * Collection col = broker.getCollectionByQuery(qry);
 * 
 * Creation date: (24.01.2001 21:45:46)
 * @author: Thomas Mahler
 * 
 */
public class QueryByCriteria implements Query
{
	private Class clazz;
	private Criteria criteria;

	/**
	 * Build a Query for class targetClass with criteria.
	 * Criteriy may be null (will result in a query returning ALL objects from a table)
	 */
	public QueryByCriteria(Class targetClass, Criteria criteria)
	{
		this.clazz = targetClass;
		this.criteria = criteria;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public Criteria getCriteria()
	{
		return criteria;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public java.lang.Object getExampleObject()
	{
		return null;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public java.lang.Class getSearchClass()
	{
		return clazz;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (07.02.2001 22:01:55)
	 * @return java.lang.String
	 */
	public String toString()
	{
		return "Query from " + clazz + " where " + criteria;
	}

}