/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package ojb.broker.query;

/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * represents a search by example.
 * "find the article with id 7"
 * could be represented as:
 * 
 * Article example = new Article();
 * example.setId(7);
 * Query qry = new QueryByExample(example);
 * 
 * The PersistenceBroker can retrieve Objects by examples as follows:
 * 
 * PersistenceBroker broker = PersistenceBrokerFactory.createPersistenceBroker();
 * Collection col = broker.getObjectByQuery(qry);
 * 
 * This Class can also handle working with OJB Identity objects:
 * "find the article with Identity xyz" could be represnted as
 * Identity xyz = new Identity(example);
 * Query qry = new QueryByExample(xyz);
 * 
 * @author: Thomas Mahler
 */
public class QueryByExample implements Query
{
	private Object exampleObject;

	/**
	 * QueryByExample can be generated from example Objects or by Identity Objects
	 */
	public QueryByExample(Object example_or_identity)
	{
		exampleObject = example_or_identity;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public Criteria getCriteria()
	{
		return null;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public java.lang.Object getExampleObject()
	{
		return exampleObject;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public java.lang.Class getSearchClass()
	{
		return exampleObject.getClass();
	}

}