/*
 * Created by IntelliJ IDEA.
 * To change template for new class use 
 * "Source Code" options (Tools | IDE Options), Templates tab.
 */
package ojb.broker.server;
import java.util.*;
import ojb.broker.PersistenceBroker;
import ojb.broker.metadata.DescriptorRepository;
import java.io.*;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;

public class BrokerPool
{
    private Vector brokers;

    private Vector freeBrokerIds;

    private static final boolean DEBUG = false;

    public static int numBrokers = 10;

    public BrokerPool(File repositoryFile)
    {
        brokers = new Vector();
        freeBrokerIds = new Vector();
        try
        {
            DescriptorRepository repository = DescriptorRepository.getInstance(repositoryFile.getAbsolutePath());
            for (int i=0; i< numBrokers; i++)
            {
                PersistenceBroker broker = new ojb.broker.PersistenceBrokerImpl(repository);
                brokers.add(broker);
                freeBrokerIds.add(new Integer(brokers.size()-1));
            }
        }
        catch(Throwable t)
        {
            System.out.println(t.getMessage());
            System.exit(0);
        }

    }

    int getFreeBrokerId()
    {
        synchronized (freeBrokerIds)
        {
            while (freeBrokerIds.isEmpty())
            {
                try
                {
                    freeBrokerIds.wait();
                }
                catch(InterruptedException e)
                {
                    continue;
                }
            }
            int result = ((Integer) freeBrokerIds.remove(0)).intValue();
            if (DEBUG) System.out.println("getFreeBrokerId: " + result + " remaining: " + freeBrokerIds);
            return result;
        }
    }


    void releaseBrokerId(int id)
    {
        synchronized (freeBrokerIds)
        {
            if (DEBUG) System.out.println("releaseBrokerId: " + id);
            freeBrokerIds.add(new Integer(id));
            freeBrokerIds.notifyAll();
            if (DEBUG) System.out.println("now: " + freeBrokerIds);
        }
    }

    PersistenceBroker getBrokerById(int id)
    {

        PersistenceBroker result = (PersistenceBroker) brokers.get(id);
         if (DEBUG) System.out.println("getBrokerById: " + id);
        return result;
    }

}