/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg;

/**
 * 
 * This LockManager implementation does nothing useful yet.
 * 
 * I provided it to get things compiled
 * 
 * @author: Thomas Mahler
 * 
 * @author: David Dixon-Peugh
 * 
 */
import ojb.odmg.lockstrategy.*;
import ojb.broker.metadata.*;
import java.util.*;

/**
 * Class declaration
 * 
 * 
 * @author
 * @version %I%, %G%
 */
public class LockManager
{

	/**
	 * the singleton instance
	 */
	private static LockManager _instance = new LockManager();

	/**
	 * 
	 * HashMap containing all locks already given out.
	 * 
	 */
	private Map allLocks = new HashMap();

	/**
	 * 
	 * LockManager constructor comment.
	 * 
	 */
	public LockManager()
	{
		super();
	}

	/**
	 * 
	 * returns the singleton instance
	 * 
	 */
	public static LockManager getInstance()
	{
		return _instance;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param obj
	 * 
	 * @return
	 * 
	 * @see
	 */
	public ReaderWriterLock getLock(Object obj)
	{
		if (allLocks.containsKey(obj))
		{
			return (ReaderWriterLock) allLocks.get(obj);
		}
		else
		{
			try
			{
				DescriptorRepository dr = DescriptorRepository.getInstance();
				ClassDescriptor cd = dr.getDescriptorFor(obj.getClass());
				ReaderWriterLock rwl = RWLockFactory.getLock(cd.getIsolationLevel());
				allLocks.put(obj, rwl);
				return rwl;
			}
			catch (ojb.broker.ClassNotPersistenceCapableException ex)
			{
				throw new org.odmg.ClassNotPersistenceCapableException(ex.getMessage());
			}
		}
	}

}