/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg;
import ojb.broker.Identity;

/**
 * 
 * represents an entry to the named roots table.
 * 
 * maps names (Strings) to OJB Identities
 * 
 * Creation date: (26.01.2001 19:57:51)
 * 
 * @author: Administrator
 * 
 */
public class NamedRootsEntry implements java.io.Serializable
{

	/**
	 * the name under which an object is registered in the NamedRoots Map
	 */
	private String name;

	/**
	 * the serialized Identity representing the named Object
	 */
	private byte[] oid;


    /**
	 *
	 * NamedRootsEntry constructor comment.
	 *
	 */
	public NamedRootsEntry(String aName, byte[] serializedOID)
	{
		this.name = aName;
		this.oid = serializedOID;
	}

    /**
	 *
	 * NamedRootsEntry constructor comment.
	 *
	 */
	public NamedRootsEntry()
	{
	}


	/**
	 * 
	 * Insert the method's description here.
	 * 
	 * Creation date: (26.01.2001 20:00:54)
	 * 
	 * @return java.lang.String
	 * 
	 */
	public java.lang.String getName()
	{
		return name;
	}

	/**
	 * 
	 * Insert the method's description here.
	 * 
	 * Creation date: (26.01.2001 20:00:54)
	 * 
	 * @return ojb.broker.Identity
	 * 
	 */
	public byte[] getOid()
	{
		return oid;
	}

}