/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg;
import java.util.Hashtable;
import org.odmg.Transaction;

/**
 * 
 * TransactionTable provides a mapping between the calling
 * 
 * thread and the Transaction it is currently using.
 * 
 * 
 * 
 * If the transaction isn't associate, it will return NULL.
 * 
 * 
 * 
 * @author     Thomas Mahler & David Dixon-Peugh
 * 
 * @created    November 15, 2000
 * 
 */
public class TransactionTable extends Object
{

	/**
	 * 
	 * the internal Hashtable mapping Transactions to threads
	 * 
	 */
	private Hashtable m_table = new Hashtable();

	/**
	 * 
	 * Creates new TransactionTable
	 * 
	 */
	public TransactionTable() {}

	/**
	 * 
	 * Retreive a Transaction associated with a thread.
	 * 
	 * 
	 * 
	 * @param  value_thread  The thread to lookup.
	 * 
	 * @return               The transaction associated with the thread.
	 * 
	 */
	public Transaction get(Thread value_thread)
	{
		return (Transaction) m_table.get(value_thread);
	}

	/**
	 * 
	 * Store the Thread/Transaction pair in the TransactionTable
	 * 
	 * 
	 * 
	 * @param  key_tx        Transaction to be associated with the thread
	 * 
	 * @param  value_thread  Thread associated with the transaction.
	 * 
	 */
	public void put(Thread value_thread, Transaction key_tx)
	{
		m_table.put(value_thread, key_tx);
	}

	/**
	 * 
	 * Remove the thread from the associated transaction.
	 * 
	 * 
	 * 
	 * @param  value_thread  Thread to be removed.
	 * 
	 */
	public void remove(Thread value_thread)
	{
		m_table.remove(value_thread);
	}

}