/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg.collections;
import java.util.Iterator;

/**
 * Insert the type's description here.
 * Creation date: (25.02.2001 12:53:12)
 * @author: Administrator
 */
public class DBagImpl extends DListImpl implements org.odmg.DBag
{

	/**
	 * DBagImpl constructor comment.
	 */
	public DBagImpl()
	{
		super();
	}

	/**
	 * DBagImpl constructor comment.
	 * @param theId int
	 * @param theSize int
	 */
	public DBagImpl(int theId, int theSize)
	{
		super(theId, theSize);
	}

	/**
	 * A new <code>DBag</code> instance is created that contains the difference of
	 * this object and the <code>DBag</code> instance referenced by <code>otherBag</code>.
	 * This method is similar to the <code>removeAll</code> method in <code>Collection</code>,
	 * except that this method creates a new collection and <code>removeAll</code>
	 * modifies the object to contain the result.
	 * @param	otherBag The other bag to use in creating the difference.
	 * @return A <code>DBag</code> instance that contains the elements of this object
	 * minus the elements in <code>otherBag</code>.
	 */
	public org.odmg.DBag difference(org.odmg.DBag otherBag)
	{
		DBagImpl result = new DBagImpl();
		Iterator iter = this.iterator();
		while (iter.hasNext())
		{
			Object candidate = iter.next();
			if (!otherBag.contains(candidate))
			{
				result.add(candidate);
			}
		}
		return result;
	}

	/**
	 * A new <code>DBag</code> instance is created that contains the intersection of
	 * this object and the <code>DBag</code> referenced by <code>otherBag</code>.
	 * This method is similar to the <code>retainAll</code> method in <code>Collection</code>,
	 * except that this method creates a new collection and <code>retainAll</code>
	 * modifies the object to contain the result.
	 * @param	otherBag The other bag to use in creating the intersection.
	 * @return A <code>DBag</code> instance that contains the intersection of this
	 * object and <code>otherBag</code>.
	 */
	public org.odmg.DBag intersection(org.odmg.DBag otherBag)
	{
		DBagImpl result = new DBagImpl();
		java.util.Iterator iter = otherBag.iterator();
		while (iter.hasNext())
		{
			Object candidate = iter.next();
			if (this.contains(candidate))
			{
				result.add(candidate);
			}
		}
		return result;
	}

	/**
	 * This method returns the number of occurrences of the object <code>obj</code>
	 * in the <code>DBag</code> collection.
	 * @param obj The value that may have elements in the collection.
	 * @return The number of occurrences of <code>obj</code> in this collection.
	 */
	public int occurrences(Object obj)
	{
		int count = 0;
		for (int i = 0; i < this.size(); i++)
		{
			if ((obj == null) ? this.get(i) == null : this.get(i).equals(obj))
			{
				count++;
			}
		}
		return count;
	}

	/**
	 * A new <code>DBag</code> instance is created that is the union of this object
	 * and <code>otherBag</code>.
	 * This method is similar to the <code>addAll</code> method in <code>Collection</code>,
	 * except that this method creates a new collection and <code>addAll</code>
	 * modifies the object to contain the result.
	 * @param	otherBag	The other bag to use in the union operation.
	 * @return A <code>DBag</code> instance that contains the union of this object
	 * and <code>otherBag</code>.
	 */
	public org.odmg.DBag union(org.odmg.DBag otherBag)
	{
		return (DBagImpl) concat((DBagImpl) otherBag);
	}

}