/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg.collections;
import ojb.broker.*;
import ojb.odmg.OJB;
import ojb.odmg.TransactionImpl;

import ojb.odmg.DatabaseImpl;

/**
 * Insert the type's description here.
 * Creation date: (28.01.2001 21:23:26)
 * @author: Administrator
 */
public class DListEntry implements java.io.Serializable
{
	protected int id;
	protected int position;
	protected Identity oid;
	protected Object realSubject;
	protected int dlistId;
	protected byte[] serializedOID;

	/**
	 * Insert the method's description here.
	 * Creation date: (09.02.2001 21:28:01)
	 */
	public DListEntry()
	{
		super();
	}

	/**
	 * DListEntry multi-args constructor used by OJB PersistenceBroker
	 */
	public DListEntry(int anId, int aDlistId, int pos, byte[] anOid)
	{
		this.id = anId;
		this.dlistId = aDlistId;
		this.position = pos;
		this.serializedOID = anOid;
		this.oid = Identity.fromByteArray(anOid);
		//TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
		//tx.register(this);
	}

	/**
	 * DListEntry constructor comment.
	 */
	public DListEntry(DListImpl theDlist, Object theObject)
	{
		this.id = generateNewId();
		this.dlistId = theDlist.getId();
		this.position = theDlist.size();
		Identity OID = new Identity(theObject);
		this.serializedOID = OID.serialize();
		this.oid = OID;
		this.realSubject = theObject;
		//TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
		//tx.register(this);
	}

	/**
	 * get a unique id
	 */
	protected int generateNewId()
	{
	    PersistenceBroker broker = PersistenceBrokerFactory.createPersistenceBroker();
        try
        {
            return broker.getUniqueId(this.getClass(), "id");
        }
        catch(PersistenceBrokerException e)
        {
            return -1;
        }
    }

	/**
	 * Insert the method's description here.
	 * Creation date: (06.02.2001 22:06:55)
	 * @return int
	 */
	public int getPosition()
	{
		return position;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (30.01.2001 22:32:10)
	 * @return java.lang.Object
	 */
	public java.lang.Object getRealSubject()
	{
		try
		{
			if (realSubject == null)
			{
				materializeRealSubject();
			}
		}
		catch (Throwable ignored)
		{
			System.out.println(ignored.getMessage());
			ignored.printStackTrace();
		}
		return realSubject;
	}

	/**
	 * retrieve the real subject from the underlying RDBMS
	 */
	private void materializeRealSubject() throws PersistenceBrokerException
	{
		realSubject = ((DatabaseImpl) OJB.getInstance().getDatabase(null)).getBroker().getObjectByIdentity(oid);
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (06.02.2001 22:06:55)
	 * @param newPosition int
	 */
	public void setPosition(int newPosition)
	{
		position = newPosition;
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (10.02.2001 17:58:45)
	 * @param newRealSubject java.lang.Object
	 */
	void setRealSubject(java.lang.Object realSubject)
	{
	    realSubject = realSubject;
	}

	/**
	 * return String representation.
	 */
	public String toString()
	{
		if (realSubject == null)
		{
			return oid.toString();
		}
		else
		{
			return realSubject.toString();
		}
	}

}