/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg.collections;
import ojb.broker.Identity;
import ojb.odmg.OJB;
import ojb.broker.SequenceManager;
import ojb.broker.PersistenceBroker;
import ojb.broker.PersistenceBrokerException;
import ojb.odmg.TransactionImpl;

import ojb.odmg.DatabaseImpl;

/**
 * Insert the type's description here.
 * Creation date: (26.02.2001 19:31:56)
 * @author: Administrator
 */
public class DMapEntry implements java.util.Map.Entry
{
	private int id;
	private int dMapId;
	private byte[] keySerializedOID;
	private Identity keyOID;
	private Object keyRealSubject;
	private byte[] valueSerializedOID;
	private Identity valueOID;
	private Object valueRealSubject;

	/**
	 * DMapEntry constructor comment.
	 */
	public DMapEntry()
	{
		super();
	}

	/**
	 * DMapEntry constructor comment.
	 */
	public DMapEntry(int id, int mapId, byte[] keySerOID, byte[] valueSerOID)
	{
		this.id = id;
		this.dMapId = mapId;
		this.keySerializedOID = keySerOID;
		this.keyOID = Identity.fromByteArray(keySerOID);
		this.valueSerializedOID = valueSerOID;
		this.valueOID = Identity.fromByteArray(valueSerOID);
		TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
		tx.register(this);
	}

	/**
	 * DMapEntry constructor comment.
	 */
	public DMapEntry(DMapImpl map, Object key, Object value)
	{
		this.id = generateNewId();
		this.dMapId = map.getId();
		this.keyRealSubject = key;
		this.keyOID = new Identity(key);
		this.keySerializedOID = this.keyOID.serialize();
		this.valueRealSubject = value;
		this.valueOID = new Identity(value);
		this.valueSerializedOID = this.valueOID.serialize();
		TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
		tx.register(this);
	}

	/**
	 * get a unique id
	 */
	protected int generateNewId()
	{
        PersistenceBroker broker = ((DatabaseImpl)OJB.getInstance().getDatabase(null)).getBroker();
        try
        {
            return broker.getUniqueId(this.getClass(), "id");
        }
        catch(PersistenceBrokerException e)
        {
            return -1;
        }
    }

	/**
	 * getKey method comment.
	 */
	public Object getKey()
	{
		try
		{
			if (keyRealSubject == null)
			{
				keyRealSubject = 
					((DatabaseImpl) OJB.getInstance().getDatabase(null)).getBroker().getObjectByIdentity(keyOID);
			}
		}
		catch (Throwable ignored)
		{
			System.out.println(ignored.getMessage());
			ignored.printStackTrace();
		}
		return keyRealSubject;
	}

	/**
	 * getValue method comment.
	 */
	public Object getValue()
	{
		try
		{
			if (valueRealSubject == null)
			{
				valueRealSubject = 
					((DatabaseImpl) OJB.getInstance().getDatabase(null)).getBroker().getObjectByIdentity(valueOID);
			}
		}
		catch (Throwable ignored)
		{
			System.out.println(ignored.getMessage());
			ignored.printStackTrace();
		}
		return valueRealSubject;
	}

	/**
	 * setValue method comment.
	 */
	public Object setValue(Object obj)
	{
		TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
		tx.register(this);
		valueRealSubject = obj;
		valueOID = new Identity(obj);
		valueSerializedOID = valueOID.serialize();
		return obj;
	}

}