/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg.collections;
import ojb.odmg.TransactionImpl;
import java.util.HashSet;
import java.util.Iterator;
import ojb.broker.SequenceManager;
import ojb.broker.PersistenceBroker;
import ojb.broker.PersistenceBrokerException;
import ojb.odmg.OJB;
import ojb.odmg.DatabaseImpl;

/**
 * Insert the type's description here.
 * Creation date: (26.02.2001 16:54:08)
 * @author: Administrator
 */
public class DMapImpl extends java.util.AbstractMap implements org.odmg.DMap
{
	private int id;
	private HashSet entries;
	private int size = 0;

	/**
	 * DMapImpl constructor comment.
	 */
	public DMapImpl()
	{
		this.id = generateNewId();
		this.entries = new HashSet();
	}

	/**
	 * DMapImpl constructor comment.
	 */
	public DMapImpl(int theId, int theSize)
	{
		id = theId;
		this.size = theSize;
		TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
		tx.register(this);
	}

	/**
	 * Returns a set view of the mappings contained in this map.  Each element
	 * in the returned set is a <tt>Map.Entry</tt>.  The set is backed by the
	 * map, so changes to the map are reflected in the set, and vice-versa.
	 * If the map is modified while an iteration over the set is in progress,
	 * the results of the iteration are undefined.  The set supports element
	 * removal, which removes the corresponding mapping from the map, via the
	 * <tt>Iterator.remove</tt>, <tt>Set.remove</tt>, <tt>removeAll</tt>,
	 * <tt>retainAll</tt> and <tt>clear</tt> operations.  It does not support
	 * the <tt>add</tt> or <tt>addAll</tt> operations.
	 * 
	 * @return a set view of the mappings contained in this map.
	 */
	public java.util.Set entrySet()
	{
		return entries;
	}

	/**
	 * return a unique id for PK
	 */
	private int generateNewId()
	{
        PersistenceBroker broker = ((DatabaseImpl)OJB.getInstance().getDatabase(null)).getBroker();
        try
        {
            return broker.getUniqueId(this.getClass(), "id");
        }
        catch(PersistenceBrokerException e)
        {
            return -1;
        }
    }

	/**
	 * Insert the method's description here.
	 * Creation date: (26.02.2001 20:02:12)
	 * @return int
	 */
	int getId()
	{
		return id;
	}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param key
	 * @param value
	 * 
	 * @return
	 * 
	 * @see
	 */
	public Object put(Object key, Object value)
	{
		TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
		tx.register(this);
		DMapEntry entry = new DMapEntry(this, key, value);
		boolean ok = entries.add(entry);
		if (ok)
		{
			return null;
		}
		else
		{
			return this.get(key);
		}
	}


    public Object remove(Object key)
    {
        Iterator i = entrySet().iterator();
        DMapEntry correctEntry = null;
        if (key==null)
        {
            while (correctEntry==null && i.hasNext())
            {
                DMapEntry e = (DMapEntry) i.next();
                if (e.getKey()==null)
                    correctEntry = e;
            }
        }
        else
        {
            while (correctEntry==null && i.hasNext())
            {
                DMapEntry e = (DMapEntry) i.next();
                if (key.equals(e.getKey()))
                    correctEntry = e;
            }
        }

        Object oldValue = null;
        if (correctEntry !=null)
        {
            oldValue = correctEntry.getValue();
            i.remove();
            TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
            tx.markDelete(correctEntry);
        }
        return oldValue;
    }



}