/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg.collections;
import java.util.Iterator;
import ojb.odmg.TransactionImpl;
import ojb.odmg.OJB;

/**
 * Insert the type's description here.
 * Creation date: (26.02.2001 13:18:55)
 * @author: Administrator
 */
public class DSetIterator implements Iterator
{
	private Iterator iter;

	private DSetEntry currentEntry = null;

	/**
	 * DListIterator constructor comment.
	 */
	public DSetIterator(DSetImpl set)
	{
		this.iter = set.getElements().iterator();
	}

	/**
	 * Returns <tt>true</tt> if the iteration has more elements. (In other
	 * words, returns <tt>true</tt> if <tt>next</tt> would return an element
	 * rather than throwing an exception.)
	 * 
	 * @return <tt>true</tt> if the iterator has more elements.
	 */
	public boolean hasNext()
	{
		return iter.hasNext();
	}

	/**
	 * Returns the next element in the interation.
	 * 
	 * @returns the next element in the interation.
	 * @exception NoSuchElementException iteration has no more elements.
	 */
	public Object next()
	{
	    currentEntry = ((DSetEntry) iter.next());
		return currentEntry.getRealSubject();
	}

	/**
	 * 
	 * Removes from the underlying collection the last element returned by the
	 * iterator (optional operation).  This method can be called only once per
	 * call to <tt>next</tt>.  The behavior of an iterator is unspecified if
	 * the underlying collection is modified while the iteration is in
	 * progress in any way other than by calling this method.
	 * 
	 * @exception UnsupportedOperationException if the <tt>remove</tt>
	 * operation is not supported by this Iterator.
	 * 
	 * @exception IllegalStateException if the <tt>next</tt> method has not
	 * yet been called, or the <tt>remove</tt> method has already
	 * been called after the last call to the <tt>next</tt>
	 * method.
	 */
	public void remove()
	{
		iter.remove();
        TransactionImpl tx = (TransactionImpl) OJB.getInstance().currentTransaction();
        tx.markDelete(currentEntry);
        currentEntry = null;

	}

}