/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg.lockstrategy;

/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * Title:        ObJectRelationalBridge
 * Description:  Object Relational Mapping tool
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author Thomas Mahler & David Dixon-Peugh
 * @version 1.0
 */
public class RWLockFactory
{

	/**
	 * Constructor declaration
	 * 
	 * 
	 * @see
	 */
	public RWLockFactory() {}

	/**
	 * Method declaration
	 * 
	 * 
	 * @param lockStrategy
	 * 
	 * @return
	 * 
	 * @see
	 */
	public static ReaderWriterLock getLock(int lockStrategy)
	{
		switch (lockStrategy)
		{
			case ReaderWriterLock.RW_READ_UNCOMMITTED:
				return new RWReadUncommittedStrategy();
			case ReaderWriterLock.RW_READ_COMMITTED:
				return new RWReadCommittedStrategy();
			case ReaderWriterLock.RW_REPEATABLE_READ:
				return new RWRepeatableReadStrategy();
			case ReaderWriterLock.RW_SERIALIZABLE:
				return new RWSerializableStrategy();
		}
		return null;
	}

}