/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/
/*
 * ObJectRelationalBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */
package ojb.odmg.lockstrategy;

/**
 * Title:        ObJectRelationalBridge
 * Description:  Object Relational Mapping tool
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author Thomas Mahler & David Dixon-Peugh
 * @version 1.0
 */
import org.odmg.Transaction;

/**
 * Interface declaration
 * 
 * 
 * @author
 * @version %I%, %G%
 */
public interface ReaderWriterLock
{
	public final int RW_READ_UNCOMMITTED = 0;
	public final int RW_READ_COMMITTED = 1;
	public final int RW_REPEATABLE_READ = 2;
	public final int RW_SERIALIZABLE = 3;

	/**
	 * Method declaration
	 * 
	 * 
	 * @return
	 * 
	 * @see
	 */
	public int getStrategy();

	/**
	 * Method declaration
	 * 
	 * 
	 * @param tx
	 * 
	 * @return
	 * 
	 * @see
	 */
	public boolean read(Transaction tx);

	/**
	 * Method declaration
	 * 
	 * 
	 * @param tx
	 * 
	 * @return
	 * 
	 * @see
	 */
	public boolean write(Transaction tx);

	/**
	 * Method declaration
	 * 
	 * 
	 * @param tx
	 * 
	 * @return
	 * 
	 * @see
	 */
	public boolean upgrade(Transaction tx);

	/**
	 * Method declaration
	 * 
	 * 
	 * @param tx
	 * 
	 * @return
	 * 
	 * @see
	 */
	public boolean release(Transaction tx);

	/**
	 * Method declaration
	 * 
	 * 
	 * @param tx
	 * 
	 * @return
	 * 
	 * @see
	 */
	public boolean checkRead(Transaction tx);

	/**
	 * Method declaration
	 * 
	 * 
	 * @param tx
	 * 
	 * @return
	 * 
	 * @see
	 */
	public boolean checkWrite(Transaction tx);

	/**
	 * Method declaration
	 * 
	 * 
	 * @param tx
	 * 
	 * @return
	 * 
	 * @see
	 */
	public String getLockType(Transaction tx);
}