// $ANTLR 2.7.1: "oql-ojb.g" -> "OQLParser.java"$


/*
 * ObJectBridge - Bridging Java Objects and Relational Databases
 * http://objectbridge.sourceforge.net
 * Copyright (C) 2000, 2001 Thomas Mahler, et al.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

/**
  * This OQL grammar has been derived from a OQL sample grammar from the ODMG WebSite.
  * The original grammar is copyright protected by MicroData Base Systems:
  * Copyright (c) 1999 Micro Data Base Systems, Inc. All rights reserved. 
  *
  * The original grammar has been modified to fit into the ObJectBridge (OJB) 
  * Persistence Managment System.
  * 
  * modifications done by Ch. Rath & Th. Mahler
  *
  * This grammar can be used to build an OQL Parser with the ANTLR Parser 
  * construction set.
  * The grammar defines a Parser that translates valid OQL Strings
  * into ojb.broker.query.Query Objects. These query objects can be used
  * to perform database queries by means of the OJB PersistenceBroker.
  * @see ojb.server.oql.OQLQueryImpl for implementation details.
  */

package ojb.odmg.oql;
 
import ojb.broker.query.*; 
 

public interface OQLLexerTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int TOK_RPAREN = 4;
	int TOK_LPAREN = 5;
	int TOK_COMMA = 6;
	int TOK_SEMIC = 7;
	int TOK_DOTDOT = 8;
	int TOK_COLON = 9;
	int TOK_DOT = 10;
	int TOK_INDIRECT = 11;
	int TOK_CONCAT = 12;
	int TOK_EQ = 13;
	int TOK_PLUS = 14;
	int TOK_MINUS = 15;
	int TOK_SLASH = 16;
	int TOK_STAR = 17;
	int TOK_LE = 18;
	int TOK_GE = 19;
	int TOK_NE = 20;
	int TOK_LT = 21;
	int TOK_GT = 22;
	int TOK_LBRACK = 23;
	int TOK_RBRACK = 24;
	int TOK_PARAMETER = 25;
	int NameFirstCharacter = 26;
	int NameCharacter = 27;
	int Identifier = 28;
	int INT_LITERAL = 29;
	int TOK_UNSIGNED_INTEGER = 30;
	int TOK_APPROXIMATE_NUMERIC_LITERAL = 31;
	int TOK_EXACT_NUMERIC_LITERAL = 32;
	int CharLiteral = 33;
	int StringLiteral = 34;
	int WhiteSpace = 35;
	int NewLine = 36;
	int CommentLine = 37;
	int MultiLineComment = 38;
	int LITERAL_select = 39;
	int LITERAL_from = 40;
	int LITERAL_where = 41;
	int LITERAL_order = 42;
	int LITERAL_by = 43;
	int LITERAL_asc = 44;
	int LITERAL_desc = 45;
	int LITERAL_or = 46;
	int LITERAL_and = 47;
	int LITERAL_like = 48;
	int LITERAL_nil = 49;
	int LITERAL_true = 50;
	int LITERAL_false = 51;
	int LITERAL_date = 52;
	int LITERAL_time = 53;
	int LITERAL_timestamp = 54;
}
