package test.ojb.broker;

import ojb.broker.VirtualProxy;
import ojb.broker.PersistenceBroker;

/**
 * Proxy class to class Article. Implements interface InterfaceArticle.
 * delegates methods calls to the internal Article-object
 * @author: thma
 */
public class ArticleProxy extends VirtualProxy implements InterfaceArticle{
/**
 * Insert the method's description here.
 * Creation date: (11.11.2000 12:57:27)
 */
public ArticleProxy()
{
	super();
}
/**
 * ArticleProxy constructor comment.
 * @param uniqueId ojb.broker.Identity
 */
public ArticleProxy(ojb.broker.Identity uniqueId, PersistenceBroker broker) {
	super(uniqueId, broker);
}
/**
 * addToStock method comment.
 */
public void addToStock(int diff)
{
	realSubject().addToStock(diff);
}
/**
 * getArticleId method comment.
 */
public int getArticleId()
{
	return realSubject().getArticleId();
}
/**
 * getArticleName method comment.
 */
public java.lang.String getArticleName()
{
	return realSubject().getArticleName();
}
/**
 * getProductGroup method comment.
 */
public InterfaceProductGroup getProductGroup()
{
	return realSubject().getProductGroup();
}
/**
 * getStockValue method comment.
 */
public double getStockValue()
{
	return realSubject().getStockValue();
}
/**
 * Insert the method's description here.
 * Creation date: (08.11.2000 22:38:26)
 * @return ojb.examples.broker.Article
 */
private InterfaceArticle realSubject()
{
	try
	{
		return (InterfaceArticle) getRealSubject();
	}
	catch (Exception e)
	{
		return null;
	}
}
/**
 * setArticleId method comment.
 */
public void setArticleId(int newArticleId)
{
	realSubject().setArticleId(newArticleId);
}
/**
 * setArticleName method comment.
 */
public void setArticleName(java.lang.String newArticleName)
{
	realSubject().setArticleName(newArticleName);
}
}