package test.ojb.broker;

public class BookArticle extends Article implements java.io.Serializable{

/** return a string representaion of an article*/
public String toString() 
{
	String group = "" + productGroupId;
	if (productGroup != null) group = productGroup.getName();
	
	return "----\n" +
	 "Article No:   " + articleId + "\n" +
	 "Description:  " + articleName + "\n" +
	 "ProductGroup: " + group + "\n" +
	 "stock:        " + stock + "\n" +
	 "price:        " + price + "\n" +
	 "stock-value   " + getStockValue() + "\n";
	 
  }                                

	/** maps to db-column "Artikel-Nr";INT;PrimaryKey*/
	private int articleId;
	/** maps to db-column Artikelname;CHAR*/
	private String articleName;
	/** maps to db-column Auslaufartikel;SMALL INT*/
	private int isSelloutArticle;
	/** maps to db-column Mindestbestand;INT*/
	private int minimumStock;
	/** maps to db-column BestellteEinheiten;INT*/
	private int orderedUnits;
	/** maps to db-column Einzelpreis;DECIMAL*/
	private double price;
	/** reference to the articles category*/
	private InterfaceProductGroup productGroup;
	/** maps to db-column Kategorie-Nr;INT*/
	private int productGroupId;
	/** maps to db-column Lagerbestand;INT*/
	private int stock;
	/** maps to db-column Lieferanten-Nr;INT*/
	private int supplierId;
	/** maps to db-column Liefereinheit;CHAR*/
	private String unit;
/** increase the amount of articles in stock by diff*/
public void addToStock(int diff)
{
	stock += diff;
}  
/**
 * return an articles unique id.
 * @return int the articles unique id
 */ 
public int getArticleId()
{
	return articleId;
}/**
 * return an articles name.
 * @return java.lang.String
 */       
public java.lang.String getArticleName()
{
	return articleName;
}/** return an articles ProductGroup*/

public double getStockValue()
{
	return price * stock;
}/**
 * set an articles unique id.
 * @param newArticleId int
 */      
public void setArticleId(int newArticleId) {
	articleId = newArticleId;
}/**
 * set an articles name.
 * @param newArticleName java.lang.String
 */      
public void setArticleName(java.lang.String newArticleName)
{
	articleName = newArticleName;
}

	/** books author*/
	private String author;
	/** ISBN No of Book*/
	private String isbn;

/**
 * Insert the method's description here.
 * Creation date: (05.01.2001 19:31:04)
 */
public BookArticle() {}

/**
 * Insert the method's description here.
 * Creation date: (05.01.2001 19:21:38)
 */
public BookArticle(
	int artId, 
	String artName, 
	int suppId, 
	int pgId, 
	String uni, 
	double pric, 
	int sto, 
	int ordUnits, 
	int minStock, 
	int isSellout)
{
	articleId = artId;
	articleName = artName;
	supplierId = suppId;
	productGroupId = pgId;
	unit = uni;
	price = pric;
	stock = sto;
	orderedUnits = ordUnits;
	minimumStock = minStock;
	isSelloutArticle = isSellout;
}



/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @return int
 */
public int getMinimumStock() {
	return minimumStock;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @return int
 */
public int getOrderedUnits() {
	return orderedUnits;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @return double
 */
public double getPrice() {
	return price;
}

public InterfaceProductGroup getProductGroup()
{
	return productGroup;
} /** compute the total value of an articles stock*/

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @return int
 */
public int getProductGroupId() {
	return productGroupId;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @return int
 */
public int getStock() {
	return stock;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @return int
 */
public int getSupplierId() {
	return supplierId;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @return java.lang.String
 */
public java.lang.String getUnit() {
	return unit;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newIsSelloutArticle int
 */
public void setIsSelloutArticle(int newIsSelloutArticle) {
	isSelloutArticle = newIsSelloutArticle;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newMinimumStock int
 */
public void setMinimumStock(int newMinimumStock) {
	minimumStock = newMinimumStock;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newOrderedUnits int
 */
public void setOrderedUnits(int newOrderedUnits) {
	orderedUnits = newOrderedUnits;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newPrice double
 */
public void setPrice(double newPrice) {
	price = newPrice;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newProductGroup Test.ojb.broker.InterfaceProductGroup
 */
public void setProductGroup(InterfaceProductGroup newProductGroup) {
	productGroup = newProductGroup;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newProductGroupId int
 */
public void setProductGroupId(int newProductGroupId) {
	productGroupId = newProductGroupId;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newStock int
 */
public void setStock(int newStock) {
	stock = newStock;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newSupplierId int
 */
public void setSupplierId(int newSupplierId) {
	supplierId = newSupplierId;
}

/**
 * Insert the method's description here.
 * Creation date: (10.12.2000 14:40:04)
 * @param newUnit java.lang.String
 */
public void setUnit(java.lang.String newUnit) {
	unit = newUnit;
}
}