package test.ojb.broker;

import junit.framework.*;
import ojb.broker.*;
import ojb.broker.metadata.*;
import ojb.broker.accesslayer.*;
import java.util.*;
import java.io.IOException;

import ojb.broker.query.*;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;

/**
 * Insert the type's description here.
 * Creation date: (06.12.2000 21:47:56)
 * @author: Administrator
 */
public class PerformanceTest extends TestCase {
	PersistenceBroker broker;



	private static Class CLASS = PerformanceTest.class;

/**
 * BrokerTests constructor comment.
 * @param name java.lang.String
 */
public PerformanceTest(String name) {
	super(name);
}
/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected Article createArticle(int id) 
{
	
	Article a = new Article();
	a.setArticleId(id);
	a.setArticleName("New Performance Article " + id);
	a.setIsSelloutArticle(true);
	a.setMinimumStock(100);
	a.setOrderedUnits(17);
	a.setPrice(0.45);
	a.setProductGroupId(1);
	a.setStock(234);
	a.setSupplierId(4);
	a.setUnit("bottle");
	return a;
	
}
/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected void deleteArticle(int id) throws PersistenceBrokerException
{
	Article a = new Article();
	a.setArticleId(id);
	broker.delete(a);
	
}
/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected void deleteArticle(Article articleToDelete) throws PersistenceBrokerException
{
	broker.delete(articleToDelete);

}
/**
 * Insert the method's description here.
 * Creation date: (23.12.2000 18:30:38)
 * @param args java.lang.String[]
 */
public static void main(String[] args)
{
	String[] arr = {CLASS.getName()};
	junit.textui.TestRunner.main(arr);
}
/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected Article readArticleByExample(int id) throws PersistenceBrokerException
{
	
	Article example = new Article();
	example.setArticleId(id);
	
	
	return (Article) broker.getObjectByQuery(QueryFactory.newQuery(example));
	
}
/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected Article readArticleByIdentity(int id) throws PersistenceBrokerException
{
	
	Article a = new Article();
	a.setArticleId(id);
	Identity oid = new Identity(a);
	
	return (Article) broker.getObjectByIdentity(oid);
	
}
/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 21:58:53)
 */
public void setUp()
{
    try
    {
        broker = PersistenceBrokerFactory.createPersistenceBroker("repository.xml");
    }
    catch(IOException e)
    {
    }
    catch(ParserConfigurationException e)
    {
    }
    catch(SAXException e)
    {
    }
}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 21:59:14)
 */
public void tearDown()
{


}











	int articleCount = 100;
	int iterations = 10;
	int offsetId = 123456;

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected void deleteArticles(int count) throws PersistenceBrokerException
{
	for (int i = 0; i < count; i++)
	{
		Article a = readArticleByExample(offsetId + i);
		broker.delete(a);
		
	}
	
}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected void insertNewArticles(int count) throws PersistenceBrokerException
{
	for (int i = 0; i < count; i++)
	{
		Article a = createArticle(offsetId + i);
		broker.store(a);
		
	}
	
}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected void readArticles(int count) throws PersistenceBrokerException
{
	for (int i = 0; i < count; i++)
	{
		Article a = readArticleByIdentity(offsetId + i);
		
	}
	
}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected void readArticlesAndUpdate(int count) throws PersistenceBrokerException
{
	for (int i = 0; i < count; i++)
	{
		Article a = readArticleByIdentity(offsetId + i);
		a.setPrice(a.getPrice() * 1.16);
		broker.store(a);
		
	}
	
}



/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 21:51:22)
 */
public void testScenario2()
{
	try
	{
		long start, elapsed;
		for (int i = 0; i < iterations; i++)
		{
			start = System.currentTimeMillis();
			broker.beginTransaction();
			insertNewArticles(articleCount);
			readArticles(articleCount);
			readArticlesAndUpdate(articleCount);
			deleteArticles(articleCount);
			broker.commitTransaction();
			elapsed = System.currentTimeMillis() - start;
			System.out.println("TestScenario2: " + elapsed + " ms");
		}
	}
	catch (Throwable t)
	{
		fail(t.getMessage());
	}
}
}