package test.ojb.broker;

import java.util.Vector;

/**
 * Tree is  recursive type: a Tree element contains some data
 * and a Vector of child Tree elements.
 * This sample demonstrates what is needed to map such a data
 * structure on a DB table
 * @author: Thomas Mahler
 */
public class TreeGroup implements java.io.Serializable {
	private int id;
	private String data;
	
	private int parentId;
	private Vector children;
	private TreeGroup myParent;

	private int groupId;
	private Vector groupMembers;
	private TreeGroup myGroup;
	


/**
 * Tree constructor comment.
 */
public TreeGroup() {
	super();
}
/**
 * Tree constructor comment.
 */
public TreeGroup(int id, String data, int parentid, int groupid)
{
	this.id = id;
	this.data = data;
	this.parentId = parentid;
	this.groupId = groupid;
}
public void addChild(TreeGroup newChild)
{
	if (children == null) children = new Vector();

	children.add(newChild);
	newChild.setParentId(this.getId());
	
}
public void addMember(TreeGroup newMember)
{
	if (groupMembers == null) groupMembers = new Vector();

	groupMembers.add(newMember);
	newMember.setGroupId(this.getId());
	
}
public TreeGroup getChild(int index)
{
	return (TreeGroup) children.get(index);
	
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @return java.util.Vector
 */
public java.util.Vector getChilds() {
	return children;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @return java.lang.String
 */
public java.lang.String getData() {
	return data;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @return int
 */
public int getGroupId()
{
	return groupId;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @return int
 */
public int getId() {
	return id;
}
public TreeGroup getMember(int index)
{
	return (TreeGroup) groupMembers.get(index);
	
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @return java.util.Vector
 */
public java.util.Vector getMembers()
{
	return groupMembers;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @return int
 */
public int getParentId() {
	return parentId;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @param newChilds java.util.Vector
 */
public void setChilds(java.util.Vector newChilds) {
	children = newChilds;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @param newData java.lang.String
 */
public void setData(java.lang.String newData) {
	data = newData;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @param newParentId int
 */
public void setGroupId(int newGroupId)
{
	groupId = newGroupId;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @param newId int
 */
public void setId(int newId) {
	id = newId;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @param newChilds java.util.Vector
 */
public void setMembers(java.util.Vector newMembers)
{
	groupMembers = newMembers;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:02)
 * @param newParentId int
 */
public void setParentId(int newParentId) {
	parentId = newParentId;
}
/**
 * Insert the method's description here.
 * Creation date: (14.02.2001 19:51:23)
 * @return int
 */
public int size()
{
	int result = 1;
	for (int i = 0; i < children.size(); i++)
	{
		result += ((TreeGroup) children.get(i)).size();
	}
	return result;
}
/**
 * Insert the method's description here.
 * Creation date: (13.02.2001 18:33:41)
 * @return java.lang.String
 */
public String toString()
{
	return data
		+ ((children == null || (children.size() == 0)) ? "" : " children: " + children.toString())
		+ ((groupMembers == null || (groupMembers.size() == 0)) ? "" : " members: " + groupMembers.toString());
}
}