package test.ojb.broker;




import java.util.Vector;
import java.util.Collection;
import java.util.Iterator;
import java.io.IOException;

import ojb.broker.metadata.*;
import ojb.broker.accesslayer.*;
import ojb.broker.*;
import ojb.broker.query.*;
import junit.framework.*;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;

/** This TestClass tests OJB facilities to work with typed collections.
  */
public class TypedCollectionsTest extends TestCase {
public static void main(String[] args)
{
	String[] arr = {CLASS.getName()};
	junit.textui.TestRunner.main(arr);
}

	PersistenceBroker broker;
	private static Class CLASS = TypedCollectionsTest.class;
	private int testId = 88888;

/**
 * Insert the method's description here.
 * Creation date: (24.12.2000 00:33:40)
 */
public TypedCollectionsTest(String name)
{
	super(name);
}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 22:15:33)
 * @param id int
 */
protected Article createArticle(int id)
{
	Article a = new Article();
	a.setArticleId(id);
	a.setArticleName("New Funny Article " + id);
	a.setIsSelloutArticle(true);
	a.setMinimumStock(100);
	a.setOrderedUnits(17);
	a.setPrice(0.45);
	a.setProductGroupId(1);
	a.setStock(234);
	a.setSupplierId(4);
	a.setUnit("bottle");
	ProductGroup tmpPG = new ProductGroup();
	tmpPG.setId(1);
	Identity pgID = new Identity(tmpPG);
	ProductGroupProxy pgProxy = new ProductGroupProxy(pgID, broker);
	a.setProductGroup(pgProxy);
	return a;
}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 21:58:53)
 */
public void setUp()
{
    try
    {
        broker = PersistenceBrokerFactory.createPersistenceBroker("repository.xml");
    }
    catch(IOException e)
    {
    }
    catch(ParserConfigurationException e)
    {
    }
    catch(SAXException e)
    {
    }


    // enable tracing of distinct system layers
	//PersistenceBrokerClient.setDebug(true);
	//JdbcAccess.setDebug(true);
	//ClassDescriptor.setDebug(true);
	//RsIterator.setDebug(true);
	//CollectionDescriptor.setDebug(true);
	//ObjectReferenceDescriptor.setDebug(true);
	//SqlGenerator.setDebug(true);
	//ObjectCache.setDebug(true);
	//RepositoryXmlHandler.setDebug(true);
	//DescriptorRepository.setDebug(true);



}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 21:59:14)
 */
public void tearDown()
{

	ObjectCache.getInstance().clear();

}



/** Test support for 1-n relations modelled with Arrays*/
public void testArray()
{
	try
	{
		for (int i = 1; i < 9; i++)
		{
			ProductGroupWithArray example = new ProductGroupWithArray();
			example.setId(i);
			ProductGroupWithArray group = (ProductGroupWithArray) broker.getObjectByQuery(new QueryByExample(example));
			assertEquals("should be equal", i, group.getId());
			System.out.println(group + "\n\n");

			broker.delete(group);
			broker.store(group);
		}
	}
	catch (Throwable t)
	{
		fail(t.getMessage());
	}
}

/** Test support for modelling 1-n relations with typed collections*/
public void testTypedCollection()
{
	try
	{
		for (int i = 1; i < 9; i++)
		{
			ProductGroupWithTypedCollection example = new ProductGroupWithTypedCollection();
			example.setId(i);
			ProductGroupWithTypedCollection group = (ProductGroupWithTypedCollection) broker.getObjectByQuery(new QueryByExample(example));
			assertEquals("should be equal", i, group.getId());
			System.out.println(group + "\n\n");

			broker.delete(group);
			broker.store(group);
		}
	}
	catch (Throwable t)
	{
		fail(t.getMessage());
	}
}
}