package test.ojb.ejb;

import java.rmi.RemoteException;

import java.util.Properties;
import javax.ejb.*;
import javax.xml.parsers.ParserConfigurationException;
import java.util.Enumeration;
import java.util.List;
import java.util.Vector;
import java.io.IOException;

import ojb.broker.*;

import ojb.broker.query.*;
import org.xml.sax.SAXException;

/**
 * This is an Entity Bean class with BMP fields.
 * You will find all neccessary to code to use the OJB PersistenceBroker
 * in the EJB context in this class.
 * @author Thomas Mahler
 */
public class PlzEntryBmpBean implements EntityBean, PlzEntry {
	private javax.ejb.EntityContext entityContext = null;
	final static long serialVersionUID = 3206093459760846163L;

	static PersistenceBroker _broker = null;

	PlzEntryImpl valueObject = null;
/**
 * ejbActivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbActivate() throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("ejbActivate()");
}
/**
 * ejbCreate method for a BMP entity bean
 * @return com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @param key com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @exception javax.ejb.CreateException The exception description.
 * @exception java.rmi.RemoteException The exception description.
 */
public PlzEntryBmpKey ejbCreate(int id) throws javax.ejb.CreateException, java.rmi.RemoteException {
	if (_trace)
		System.out.println("ejbCreate(" + id + ")");
	valueObject = new PlzEntryImpl();
	valueObject.setId(id);
	valueObject.getMod().setNeedsInsert(true);
	try
	{
		getBroker().store(valueObject, valueObject.getMod());
	}
	catch (PersistenceBrokerException ex)
	{
		throw new javax.ejb.CreateException(ex.getMessage());
	}
	return new PlzEntryBmpKey(id);
}

/**
 * ejbFindByPrimaryKey method comment
 * @return com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @param primaryKey com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.FinderException The exception description.
 */
public PlzEntryBmpKey ejbFindById( int id)
	throws java.rmi.RemoteException, javax.ejb.FinderException 
{
	if (_trace) System.out.println("ejbFindById(" + id + ")");
	PlzEntryBmpKey primaryKey = new PlzEntryBmpKey(id);
	PlzEntryIdentity oid = new PlzEntryIdentity(id);
	loadUsingOid(oid);
	return primaryKey;
}
/**
 * ejbFindByPrimaryKey method comment
 * @return com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @param primaryKey com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.FinderException The exception description.
 */
public PlzEntryBmpKey ejbFindByPrimaryKey( PlzEntryBmpKey primaryKey)
	throws java.rmi.RemoteException, javax.ejb.FinderException 
{
	if (_trace) System.out.println("ejbFindByPrimaryKey(" + primaryKey +")");
	PlzEntryIdentity oid = new PlzEntryIdentity(primaryKey.id);
	loadUsingOid(oid);
	return primaryKey;
}
/**
 * ejbFindByPrimaryKey method comment
 * @return com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @param primaryKey com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.FinderException The exception description.
 */
public Enumeration ejbFindByTown(String town) throws java.rmi.RemoteException, javax.ejb.FinderException {
	if (_trace)
		System.out.println("ejbFindByTown(" + town + ")");
	Criteria criteria = new Criteria();
	criteria.addEqualTo("town", town);
	Query query = QueryFactory.newQuery(PlzEntryImpl.class, criteria);
	try
	{
		return getBroker().getPKEnumerationByQuery(PlzEntryBmpKey.class, query);
	}
	catch (PersistenceBrokerException ex)
	{
		throw new javax.ejb.FinderException(ex.getMessage());
	}
}
/**
 * ejbLoad method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbLoad() throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("ejbLoad()");
	PlzEntryBmpKey pk = (PlzEntryBmpKey) entityContext.getPrimaryKey();
	PlzEntryIdentity oid = new PlzEntryIdentity(pk.id);
	loadUsingOid(oid);	
}
/**
 * ejbPassivate method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbPassivate() throws java.rmi.RemoteException 
{
	if (_trace)
		System.out.println("ejbPassivate()");
}

/**
 * ejbRemove method comment
 * @exception java.rmi.RemoteException The exception description.
 * @exception javax.ejb.RemoveException The exception description.
 */
public void ejbRemove() throws java.rmi.RemoteException, javax.ejb.RemoveException {
	if (_trace)
		System.out.println("ejbRemove()");
	try
	{
		getBroker().delete(valueObject);
	}
	catch (PersistenceBrokerException ex)
	{
		throw new javax.ejb.RemoveException(ex.getMessage());
	}
}
/**
 * ejbStore method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbStore() throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("ejbStore()");
	try
	{
	getBroker().store(valueObject, valueObject.getMod());
	}
	catch (PersistenceBrokerException ex)
	{
		throw new java.rmi.RemoteException(ex.getMessage());
	}
}
/**
 * Insert the method's description here.
 * Creation date: (23.11.00 14:43:35)
 * @return ojb.broker.PersistenceBroker
 */
private PersistenceBroker getBroker() 
{
	if (_broker == null)
	{
        try
        {
            _broker = PersistenceBrokerFactory.createPersistenceBroker("c:\\repository.xml");
        }
        catch(IOException e)
        {
        }
        catch(ParserConfigurationException e)
        {
        }
        catch(SAXException e)
        {
        }
    }
	return _broker;
}
/**
 * getEntityContext method comment
 * @return javax.ejb.EntityContext
 */
public javax.ejb.EntityContext getEntityContext() {
	if (_trace) System.out.println("getEntityContext()");
	return entityContext;
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @return java.lang.String
 */
public java.lang.String getHnumber() throws java.rmi.RemoteException {
	if (_trace) System.out.println("getHnumber()");
	return valueObject.getHnumber();
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @return int
 */
public int getId() throws java.rmi.RemoteException {
	if (_trace) System.out.println("getId()");
	return valueObject.getId();
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @return java.lang.String
 */
public java.lang.String getPostalcode() throws java.rmi.RemoteException {
	if (_trace) System.out.println("getPostalcode()");
	return valueObject.getPostalcode();
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:55:03)
 * @return java.lang.String
 */
public java.lang.String getReserve() throws java.rmi.RemoteException {
	if (_trace) System.out.println("getReserve()");
	return valueObject.getReserve();
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @return java.lang.String
 */
public java.lang.String getSmalltown() throws java.rmi.RemoteException {
	if (_trace) System.out.println("getSmalltown()");
	return valueObject.getSmalltown();
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @return java.lang.String
 */
public java.lang.String getStreet() throws java.rmi.RemoteException {
	if (_trace) System.out.println("getStreet()");
	return valueObject.getStreet();
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @return java.lang.String
 */
public java.lang.String getTown() throws java.rmi.RemoteException {
	if (_trace) System.out.println("getTown()");
	return valueObject.getTown();
}
/**
 * Insert the method's description here.
 * Creation date: (23.11.00 14:30:07)
 * @param oid com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryIdentity
 */
private void loadUsingOid(PlzEntryIdentity oid)
{
	if (_trace)
		System.out.println("loadUsingOid(" + oid + ")");
	PersistenceBroker broker = getBroker();
	try
	{
		valueObject = (PlzEntryImpl) broker.getObjectByIdentity(oid);
	}
	catch (PersistenceBrokerException ex)
	{
	}
}
/**
 * setEntityContext method comment
 * @param ctx javax.ejb.EntityContext
 * @exception java.rmi.RemoteException The exception description.
 */
public void setEntityContext(javax.ejb.EntityContext ctx) throws java.rmi.RemoteException {
	if (_trace) System.out.println("setEntityContext(...)");
	entityContext = ctx;
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @param newHnumber java.lang.String
 */
public void setHnumber(java.lang.String newHnumber) throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("setHnumber(" + newHnumber + ")");
	valueObject.setHnumber(newHnumber);
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @param newId int
 */
public void setId(int newId) throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("setId(" + newId + ")");
	valueObject.setId(newId);
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @param newPostalcode java.lang.String
 */
public void setPostalcode(java.lang.String newPostalcode) throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("setPostalcode(" + newPostalcode + ")");
	valueObject.setPostalcode(newPostalcode);
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:55:03)
 * @param newTown java.lang.String
 */
public void setReserve(java.lang.String newReserve)
	throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("setReserve(" + newReserve + ")");
	valueObject.setReserve(newReserve);
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @param newSmalltown java.lang.String
 */
public void setSmalltown(java.lang.String newSmalltown)
	throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("setSmalltown(" + newSmalltown + ")");
	valueObject.setSmalltown(newSmalltown);
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @param newStreet java.lang.String
 */
public void setStreet(java.lang.String newStreet)
	throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("setStreet(" + newStreet + ")");
	valueObject.setStreet(newStreet);
}
/**
 * Insert the method's description here.
 * Creation date: (24.11.00 12:00:53)
 * @param newTown java.lang.String
 */
public void setTown(java.lang.String newTown) throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("setTown(" + newTown + ")");
	valueObject.setTown(newTown);
}
/**
 * unsetEntityContext method comment
 * @exception java.rmi.RemoteException The exception description.
 */
public void unsetEntityContext() throws java.rmi.RemoteException {
	if (_trace) System.out.println("unsetEntityContext()");
	entityContext = null;
}

	final static boolean _trace = true;

/**
 * ejbCreate method for a BMP entity bean
 * @return com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @param key com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @exception javax.ejb.CreateException The exception description.
 * @exception java.rmi.RemoteException The exception description.
 */
public PlzEntryBmpKey ejbCreate(PlzEntryBmpKey key) throws javax.ejb.CreateException, java.rmi.RemoteException {
	if (_trace) System.out.println("ejbCreate(" + key + ")");
	return null;
}

/**
 * ejbPostCreate method for a BMP entity bean
 * @param key com.itellium.aeservices.j2ee.gamsy.plz.bmp.PlzEntryBmpKey
 * @exception java.rmi.RemoteException The exception description.
 */
public void ejbPostCreate(PlzEntryBmpKey key) throws java.rmi.RemoteException 
{
	if (_trace) System.out.println("ejbPostCreate(" + key + ")");
}
}