package test.ojb.odmg;




import java.util.Vector;
import java.util.Collection;
import java.util.Iterator;

import ojb.broker.accesslayer.*;
import ojb.broker.*;
import ojb.odmg.collections.DListImpl;
import ojb.odmg.*;
import org.odmg.*;
import junit.framework.*;

/** Demo Application that shows basic concepts for Applications using the OJB ODMG
  * implementation as an transactional object server.
  */
public class DMapTest extends TestCase {
public static void main(String[] args)
{
	String[] arr = {CLASS.getName()};
	junit.textui.TestRunner.main(arr);
}

	private static Class CLASS = DMapTest.class;
	private String databaseName;

/**
 * Insert the method's description here.
 * Creation date: (24.12.2000 00:33:40)
 */
public DMapTest(String name)
{
	super(name);
}

protected Article createArticle() 
{
	
	Article a = new Article();
    PersistenceBroker broker = ((DatabaseImpl)OJB.getInstance().getDatabase(null)).getBroker();
    try
    {
        a.setArticleId(broker.getUniqueId(Article.class, "articleId"));
    }
    catch(PersistenceBrokerException e)
    {
    }
    a.setArticleName("New Funny Article " + a.getArticleId());
	
	a.setStock(234);
	
	return a;
	
}

protected void printDList(DList list)
{
	Iterator iter = list.iterator();
	while (iter.hasNext())
	{
		Article a = (Article) iter.next();
		System.out.print(a.getArticleId() + ", ");
	}
	System.out.println();
}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 21:58:53)
 */
public void setUp()
{
	databaseName = "repository.xml";

	// enable tracing of distinct system layers
	//PersistenceBrokerClient.setDebug(true);
	//JdbcAccess.setDebug(true);
	//ClassDescriptor.setDebug(true);
	//RsIterator.setDebug(true);
	//CollectionDescriptor.setDebug(true);
	//ObjectReferenceDescriptor.setDebug(true);
	//SqlGenerator.setDebug(true);
	//ObjectCache.setDebug(true);
	//RepositoryXmlHandler.setDebug(true);
	//DescriptorRepository.setDebug(true);


}

/**
 * Insert the method's description here.
 * Creation date: (06.12.2000 21:59:14)
 */
public void tearDown()
{
	try
	{
		OJB.getInstance().currentTransaction().abort();
		OJB.getInstance().getDatabase(null).close();
		databaseName = null;

		
	}
	catch (Throwable t)
	{
	}
}

public void testAdding()
{
	try
	{
		// get facade instance
		Implementation odmg = OJB.getInstance();
		Database db = odmg.newDatabase();
		//open database
		db.open(databaseName, Database.OPEN_READ_WRITE);
		Transaction tx = odmg.newTransaction();
		tx.begin();
		DMap map = odmg.newDMap();
        PersistenceBroker broker = ((DatabaseImpl)OJB.getInstance().getDatabase(null)).getBroker();
        String name = null;
        try
        {
            name = "the_dmap_" + (broker.getUniqueId(ojb.odmg.collections.DMapImpl.class, "id") - 1);
        }
        catch(PersistenceBrokerException e)
        {
        }
        db.bind(map, name);
		Article key1 = createArticle();
		Article val1 = createArticle();
		Article key2 = createArticle();
		Article val2 = createArticle();

		map.put(key1, val1);
		map.put(key2, val2);

		tx.commit();
		tx = odmg.newTransaction();
		tx.begin();

		DMap mapA = (DMap) db.lookup(name);
		Article val1A = (Article) mapA.get(key1);
		assertEquals(val1.getArticleId(), val1A.getArticleId());
		Article val2A = (Article) mapA.get(key2);
		assertEquals(val2.getArticleId(), val2A.getArticleId());

		tx.commit();
	}
	catch (Throwable ex)
	{
		fail(ex.getMessage());
	}

}


}