package test.ojb.odmg;

import java.util.Vector;


import ojb.odmg.*;
import ojb.broker.Identity;

/** represents a product group containing a set of Articles.
  * @see Article
  */
public class ProductGroup implements ojb.odmg.TransactionAware
{
/** return group id*/
public int getId()
{
	return groupId;
}
  
/**return string representation*/
public String toString() 
{
	return 
		"----\n" +
  		"group Id:    " + groupId + "\n" +
	 	"name:        " + groupName + "\n" +
	 	"description: " + description + "\n"+
	 	"articles in group: " + allArticlesInGroup;
}      

/** return groupname*/
public String getName()
{
	return groupName;
}

	/** collection containing all articles of a given product group*/
	private Vector allArticlesInGroup;
	/** a textual description of the group*/
	private String description;
	/** the unique id of a product group*/
	private int groupId;
	/** the name of a group*/
	private String groupName;
public java.lang.String getDescription() {
	return description;
}/**
 * Insert the method's description here.
 * Creation date: (02.11.2000 22:29:28)
 * @param newDescription java.lang.String
 */    
public void setDescription(java.lang.String newDescription)
{
	if (newDescription != description)
	{
		description = newDescription;
	}
}

/**
  * afterAbort will be called after a transaction has been aborted.
  * The values of fields which get persisted will have changed to
  * what they were at the begining of the transaction.  This method
  * should be overridden to reset any transient or non-persistent
  * fields.
  */
public void afterAbort()
{
	System.out.println("afterAbort: " + new Identity(this));
}

/**
  * afterCommit is called only after a successful commit has taken
  * place.
  */
public void afterCommit()
{
	System.out.println("afterCommit: " + new Identity(this));
}

/**
  * beforeAbort is called before a transaction is aborted.
  */
public void beforeAbort()
{
	System.out.println("beforeAbort: " + new Identity(this));
}

/**
  * beforeCommit will give an object a chance to kill a
  * transaction before it is committed.
  *
  * To kill a transaction, throw a new TransactionAbortedException.
  */
public void beforeCommit() throws org.odmg.TransactionAbortedException {
	System.out.println("beforeCommit: " + new Identity(this));
}





/** set groupname*/
public void setName(String newName)
{
	groupName = newName;
}
}