package test.ojb.server;

/**
 * Title:        StateMachine Verifier
 * Description:  This project is to investigate using State Machine
 * Equivalence as a method of Software Testing.
 * Copyright:    Copyright (c) 2000
 * @author David Dixon-Peugh
 * @version 1.0
 */

import java.util.*;

public class ModelState {
  private List trans = new ArrayList();
  private Map transMap = new HashMap();
  private String name;
  private String ID;
  private boolean start;

  public ModelState() {
  }

  public void addTransition( ModelTransition t ) {
    transMap.put(t.getName(), t);
    trans.add( t );
  }

  public ModelTransition getTransition( String t ) {
    return (ModelTransition) transMap.get(t);
  }

  public List getTransitions() {
    return trans;
  }

  public String getName() {
    return name;
  }

  public boolean isStart() {
    return start;
  }

  public String getID() {
    return ID;
  }

  public void setName( String newName ) {
    name = newName;
  }

  public void setID( String newID ) {
    ID = newID;
  }

  public void setStart( boolean newStart ) {
    start = newStart;
  }

}