package test.ojb.server.lockstrategy;

/**
 * Title:        ObJectBridge
 * Description:  Object Relational Mapping tool
 * Copyright:    Copyright (c) 2000
 * Company:
 * @author Thomas Mahler & David Dixon-Peugh
 * @version 1.0
 */
import ojb.server.lockstrategy.*;
import ojb.server.*;

import org.odmg.Transaction;
import test.ojb.server.StateMachine;


public class ReaderWriterSMTest implements StateMachine {
  private int strategy = ReaderWriterLock.RW_SERIALIZABLE;

  ReaderWriterLock rwl;

  Transaction txa;
  Transaction txb;

  public ReaderWriterSMTest() {
    start();
  }

  public void setStrategy( int lockStrategy ) {
    strategy = lockStrategy;
  }
  public void start() {
    TransactionTable tt = new TransactionTable();
    rwl = RWLockFactory.getLock( strategy );
    txa = new TransactionImpl(tt);
    txb = new TransactionImpl(tt);
  }

  public boolean transition(String trans) {
    if (trans.equals( "txaRead" ))    return txaRead();
    if (trans.equals( "txaWrite" ))   return txaWrite();
    if (trans.equals( "txaUpgrade" )) return txaUpgrade();
    if (trans.equals( "txaRelease"))  return txaRelease();

    if (trans.equals( "txbRead" ))    return txbRead();
    if (trans.equals( "txbWrite" ))   return txbWrite();
    if (trans.equals( "txbUpgrade" )) return txbUpgrade();
    if (trans.equals( "txbRelease" )) return txbRelease();

    return false;
  }

  public String getState() {
    return rwl.getLockType(txa) + rwl.getLockType(txb);
  }

  public boolean txaRead() {
    return rwl.read(txa);
  }

  public boolean txaWrite() {
    return rwl.write(txa);
  }

  public boolean txaUpgrade() {
    return rwl.upgrade(txa);
  }

  public boolean txaRelease() {
    return rwl.release(txa);
  }

  public boolean txbRead() {
    return rwl.read(txb);
  }

  public boolean txbWrite() {
    return rwl.write(txb);
  }

  public boolean txbUpgrade() {
    return rwl.upgrade(txb);
  }

  public boolean txbRelease() {
    return rwl.release(txb);
  }
}