package test.ojb.tutorial1;

import java.io.*;
import ojb.broker.*;
/**
 * Insert the type's description here.
 * Creation date: (04.03.2001 10:34:15)
 * @author: Administrator
 */
public class UCEnterNewProduct extends AbstractUseCase {
/**
 * UCEnterNewProduct constructor comment.
 */
public UCEnterNewProduct(PersistenceBroker broker)
{
	super(broker);
}
/** perform this use case*/
public void apply()
{
	// this will be our new object
	Product newProduct = new Product();
	// now read in all relevant information and fill the new object:
	System.out.println("please enter a new product");
	String in = readLineWithMessage("enter name:");
	newProduct.setName(in);
	in = readLineWithMessage("enter price:");
	newProduct.setPrice(Double.parseDouble(in));
	in = readLineWithMessage("enter available stock:");
	newProduct.setStock(Integer.parseInt(in));
	
	// now perform persistence operations
	try
	{
		// 1. open transaction
		broker.beginTransaction();
		// 2. we need a unique id for the new Object.
		newProduct.setId(broker.getUniqueId(Product.class, "_id"));
		// 3. make the new object persistent
		broker.store(newProduct);
		broker.commitTransaction();
	}
	catch (PersistenceBrokerException ex)
	{
	    // if something went wrong: rollback
		broker.abortTransaction();
		System.out.println(ex.getMessage());
		ex.printStackTrace();
	}
}
/** get descriptive information on use case*/
public String getDescription()
{
	return "Enter a new product";
}
}
