package test.ojb.tutorial2;

import ojb.odmg.*;
import org.odmg.*;

/**
 * Insert the type's description here.
 * Creation date: (04.03.2001 10:34:15)
 * @author: Administrator
 */
public class UCDeleteProduct extends AbstractUseCase {
/**
 * UCEnterNewProduct constructor comment.
 */
	public UCDeleteProduct(Implementation impl)
	{
		super(impl);
	}
/** perform this use case*/
	public void apply()
	{
		String in = readLineWithMessage("Delete Product with id:");
		int id = Integer.parseInt(in);


		// We don't have a reference to the selected Product.
		// So first we have to lookup the object, we do it
		// through an ODMG "named roots lookup"

		// 1. build name for named roots lookup:
		String name = "product_" + id;

		Database db = odmg.getDatabase(null); // the current DB
		Transaction tx = null;
		try
		{
			// 2. start transaction
			tx = odmg.newTransaction();
			tx.begin();

			// 3. lookup the product specified by named roots lookup
			Product toBeDeleted = (Product) db.lookup(name);
			// 4. now mark object for deletion
			db.deletePersistent(toBeDeleted);
			// 5. commit transaction
			tx.commit();
		}
		catch (Throwable t)
		{
			// rollback in case of errors
			tx.abort();
			t.printStackTrace();
		}
	}
/** get descriptive information on use case*/
	public String getDescription()
	{
		return "Delete a product entry";
	}
}