package test.ojb.tutorial2;

import java.io.*;
import ojb.odmg.*;
import org.odmg.*;
import ojb.broker.SequenceManager;
import ojb.broker.PersistenceBroker;

/**
 * Insert the type's description here.
 * Creation date: (04.03.2001 10:34:15)
 * @author: Administrator
 */
public class UCEnterNewProduct extends AbstractUseCase {

	public UCEnterNewProduct(Implementation impl)
	{
		super(impl);
	}

/** perform this use case*/
	public void apply()
	{
		// this will be our new object
		Product newProduct = new Product();
		// now read in all relevant information and fill the new object:
		System.out.println("please enter a new product");
		String in = readLineWithMessage("enter name:");
		newProduct.setName(in);
		in = readLineWithMessage("enter price:");
		newProduct.setPrice(Double.parseDouble(in));
		in = readLineWithMessage("enter available stock:");
		newProduct.setStock(Integer.parseInt(in));

		// now perform persistence operations
		Transaction tx = null;
		try
		{
			// 1. open transaction
			tx = odmg.newTransaction();
			tx.begin();

			// 2. we need a unique id for the new Object.
            PersistenceBroker broker = ((DatabaseImpl)OJB.getInstance().getDatabase(null)).getBroker();

			newProduct.setId(broker.getUniqueId(Product.class, "_id"));

			// 3. create a unique name for the object to perfom named root lookups later;
			String name = "product_" + newProduct.getId();

			// 4. bind new object to this name for later reference:
			odmg.getDatabase(null).makePersistent(newProduct); 
// temporary workaround for a bug in bind
			odmg.getDatabase(null).bind(newProduct, name);
			// 5. commit transaction
			tx.commit();
		}
		catch (ODMGException ex)
		{
			// if something went wrong: rollback
			tx.abort();
			System.out.println(ex.getMessage());
			ex.printStackTrace();
		}
	}
/** get descriptive information on use case*/
	public String getDescription()
	{
		return "Enter a new product";
	}
}