package test.ojb.tutorial2;

import java.util.Collection;
import ojb.broker.query.*;
import ojb.broker.*;
import ojb.odmg.*;
import org.odmg.*;

/**
 * Insert the type's description here.
 * Creation date: (04.03.2001 10:34:15)
 * @author: Administrator
 */
public class UCListAllProducts extends AbstractUseCase {
/**
 * UCEnterNewProduct constructor comment.
 */
	public UCListAllProducts(Implementation impl)
	{
		super(impl);
	}
/** perform this use case*/
	public void apply()
	{
		System.out.println("The list of available products:");
		try
		{


            		// 1. open a transaction 
			Transaction tx = odmg.newTransaction(); 
			tx.begin(); 

			// 2. get an OQLQuery object from the ODMG facade
			OQLQuery query = odmg.newOQLQuery(); 

			// 3. set the OQL select statement
			query.create("select allproducts from " + Product.class.getName()); 

			// 4. perform the query and store the result in a persistent Collection
			DList allProducts = (DList) query.execute(); 
			tx.commit();

			// 5. now iterate over the result to print each product 
			java.util.Iterator iter = allProducts.iterator(); 
			while (iter.hasNext()) 
			{ 
				System.out.println(iter.next()); 
			} 

		}
		catch (Throwable t)
		{
			t.printStackTrace();
		}
	}
/** get descriptive information on use case*/
	public String getDescription()
	{
		return "List all product entries";
	}
}
